#ifndef GPUDM_H_DEFINED
#define GPUDM_H_DEFINED

//delta-eddington, tree-layered and two-layered
void ReflE2L3(float mua1, float mus1, float mua2, float mus2, float mua3, float mus3, float gcol, float *res, float d1, float d2);
void ReflE2L2(float mua1, float mus1, float mua2, float mus2, float gcol, float *res, float *derivmuad, float *derivmuae);

//isotropic source function, two-layered and three-layered and one-layered
void ReflIsoL2(float muae, float muse, float muad, float musd, float gcol, float *res, float *derivmuad, float *derivmuae);
void ReflIsoL2(float muae, float muse, float muad, float musd, float gcol, float *res, float *deriv);
void ReflIsoL3(float mua1, float mus1, float mua2, float mus2, float mua3, float mus3, float gcol, float d1, float d2, float *res);
void ReflIsoL1(float mua, float mus, float gcol, float *res, float *deriv);

//for finding the next muad/muae given derivatives and reflectance value
void nextMuad(float lineData, float refl, float deriv, float *muad, float safeinit);

//skin data calculation
void calcSkinData(float lambda, float oxy1, float Bd1, float oxy2, float Bd2, float muam694, float bil, float car, float met, float wat, float *mua1, float *mus1, float *mua2, float *mus2, float *mua3, float *mus3, float *gcol); //setter ekstrakromoforene i lag 3
void calcSkinData(float lambda, float oxy1, float Bd1, float oxy2, float Bd2, float muam694, float bil2, float bil3, float car1, float car3, float met2, float met3, float wat1, float wat2, float wat3, float *mua1, float *mus1, float *mua2, float *mus2, float *mua3, float *mus3, float *gcol);

#endif 
