#ifndef BASE_H_DEFINED
#define BASE_H_DEFINED

#include <vector>


//base spectral dependencies
struct GPUSkinBase{
	float *muh_oxy;
	float *muh_deoxy;
	float *melanin_base; //contains (695/lambda)^3.46
	float *gcol; //anisotropy factor for collagen
	float *musm; //unreduced mie scattering
	float *musr; //unreduced rayleigh scattering coefficient
	float *musb_base; //unreduced blood scattering coefficient
	float *wavelengths; //wavelengths
	void allocate(int samples, int bands, size_t byteWidthPerBlock, int numberOfBlocks, const std::vector<float> &wavelengths);
};

//skin data
struct GPUSkinData{
	float *muam694;
	float *bvf;
	float *oxy;
	float *melanin_type; //SVAASAND_MELANIN_GPU, EUMELANIN_GPU or PHEOMELANIN_GPU
	void allocate(size_t byteWidthPerBlock, int numberOfBlocks, int thrPerBl);
	float *download(int samples); //download all arrays to an host array
	size_t pitch;
	int height;
	size_t byteWidth;
};

//optical properties
struct GPUOpticalProps{
	float *muae;
	float *muse;
	float *muad;
	float *musd;
	void allocate(size_t byteWidthPerBlock, int numberOfBlocks);
};

#endif
