class CalibrationStage{ //inherited classes are omitted
	public:
		CalibrationStage(int bands, int samples, float *calarr, float calfact, std::vector<float> wlens); //bands, samples, wlens are propertes of the incoming hyperspectral image, which should in reality be detected at the first iteration of the execution loop.

		//
		// omitted framework functions
		//
		
		cv::Mat segment(cv::Mat inputImage, cv::Mat inputBinary, int threshold, bool shouldMult); //segment image based on some threshold, and multiply it against some other image
		float* detectan(float *inputImage, int height, int width); //full calibration detection, old images with paper strip and circular reflectance standard
		float* easyDetect(float *inputImage, int height); //just something to collect data from pre-defined calibration slab
		bool *skinThresh(float *inputImage); //returns a binary cv::Mat object containing 1 where there should be skin and 0 where there should be not
	private:
		int _samples; //samples in the output image
		int _imageInputSamples; //samples in the input image
		int _lines; //lines per block of data
		int _bands;
		std::vector<float> _wlens;

		float* _calarray; //contains calibration arrays after successful detection
		float _calfactor; //reflectance standard factor, usually 0.4, 0.5 or 0.99
		float *_buffer;

		//omitted framework variables
};
