#ifndef CHROMOPHORES_H_DEFINED
#define CHROMOPHORES_H_DEFINED


class Chromophores{
	public:
		Chromophores(); //blood is set as standard
		void checkAndSet(bool *val);
		void checkAndUnset(bool *val);

		void setWat(){checkAndSet(&haswat);};
		void setKonst(){checkAndSet(&haskonst);};
		void setMel(){checkAndSet(&hasmel);};
		void setMethb(){checkAndSet(&hasmethb);};
		void setBil(){checkAndSet(&hasbil);};
		void setBet(){checkAndSet(&hasbet);};
		void setDeoxy(){checkAndSet(&hasdeoxy);};
		void setOxy(){checkAndSet(&hasoxy);};
		void setCOHb(){checkAndSet(&hascohb);};

		void unsetWat(){checkAndUnset(&haswat);};
		void unsetKonst(){checkAndUnset(&haskonst);};
		void unsetMel(){checkAndUnset(&hasmel);};
		void unsetMethb(){checkAndUnset(&hasmethb);};
		void unsetBil(){checkAndUnset(&hasbil);};
		void unsetBet(){checkAndUnset(&hasbet);};
		void unsetDeoxy(){checkAndUnset(&hasdeoxy);};
		void unsetOxy(){checkAndUnset(&hasoxy);};
		void unsetCOHb(){checkAndUnset(&hascohb);};

		int getNumEndmembers(){return numEnd;};
		float *getAbsArray(float w); //returns absorption array across all chromophores
		float getAbs(float w, int end); //returns absorption for specified chromophore
		int getMelInd(); //returns the index corresponding to melanin
		int getMethbInd(); //returns the index corresponding to methemoglobin
	private:
		bool hasoxy;
		bool hasdeoxy;
		bool haswat;
		bool haskonst;
		bool hasmel;
		bool hasmethb;
		bool hasbil;
		bool hasbet;
		bool hascohb;



		int numEnd;

};

#endif
