//remove muam694-component from input mua
__global__ void removeMuam(float *mua, float *endvalues, float *AT, int startblockInd, int numBands, int endmembers, int muamInd, size_t pitch);

//perform moving average of size samples on the input array
template<int BLOCK_DIM>
__global__ void movingAverage(float *arr, float *outarr, int samplesdiv2, size_t pitch);


//deinitializing muam
__global__ void muamDeinit(float *muam, size_t pitch);

__global__ void skindataDeinit(float *muam, float *bvf, float *oxy, float *melanin_type, size_t pitch);

//check scaling of muad at wavelengths 1 and 2 and move the melanin type up one step. PHEOMELANIN_GPU -> SVAASAND_MELANIN_GPU -> EUMELANIN_GPU -> ??? wrong scattering
__global__ void CheckReflectanceScaling(float *muad, float *melanin_type, int wlenind1, int wlenind2, size_t pitch, float scaling_thresh);

__global__ void SetMelaninType(float *melanin_type, int inputType, size_t pitch);

//penetration depth calculations
__device__ float calcPenDepth(float muae, float muad, float musd, float gcol);
__global__ void PenDepths(float *muae, float *muad, float *muse, float *musd, float *gcol, int startwlenind, int endwlenind, size_t pitch, float *pendepths, float *pendepthsstd);


//ordinary least squares. Both implementations are in reality unoptimized. Uses interpolation. Uppers and downers contain indices for interpolation.  
__global__ void GPUlseunoptim(float *lsemat, float *input, float *res, float startWlen, float stepWlen, int antWlens, int *uppers, int *downers, float *upperwlens, float *downerwlens, size_t pitch, size_t intPitch);
__global__ void GPUlseOptim(float *lsemat, float *input, float *res, int startind, int endind, int *numWlens, float *wlens, float *startwlens, int antWlens, size_t pitch, size_t intPitch);

//calculate oxy and bvf based on absorption coefficients
__global__ void calcOxyBvf(float *inputRes, float *oxyOut, float *bvfOut, size_t pitch);

//NNLS using ISRA
template<int MAX_NUM_BANDS>
__global__ void ISRA(float *mua, float *endout, float *chromarr, size_t pitch, int startwlenInd, int numEndmembers, int numBands);

//implementation of SCA using shared memory
template<int MAX_ENDMEMBERS, int MAX_BLOCKDIM>
__global__ void SCA(float *AT, float *H, float *inputmua, float *x, float *mu, float *prevChrom, int prevMethbind, int currMethbind, int startind, int numBands, int numEndmembers, size_t pitch);

//implementation of SCA using registers
template<int MAX_ENDMEMBERS>
__global__ void SCAFast(float *AT, float *H, float *inputmua, float *x, float *mu, float *prevChrom, int prevMethbind, int currMethbind, int startind, int numBands, int numEndmembers, size_t pitch);
