#ifndef FITTING_H_DEFINED
#define FITTING_H_DEFINED

//general fitting class, for generating interpolation tables and such 
class Fitting{
	public:
		Fitting(Chromophores chrom, const std::vector<float> &wlens, float startwlen, float endwlen, int samples, int bands);
		void generateInterpolTables(); //creates interpolation tables for later interpolation
		static float** generateChromophoreMatrix(Chromophores chrom, float startwlen, int antWlens, int endmembers); //generates chromophore matrix for the specified wavelengths
		
	protected:
		//image properties
		int _endmembers;
		int _samples;
		int _bands;
		
		//interpolation properties
		int _startwlen;
		int _antWlens;
	
		//interpolation arrays
		float *_upperWlens;
		float *_downerWlens;

		//interpolation indices. Uppers are upper indices corresponding to wavelength number i from _minWlen, downers are lower indices
		float _minWlen;
		float _maxWlen;
		float _stepWlen;

		std::vector<float> _wlens;
		
		Chromophores _chrom;
		void lseprep();
		int *_uppers;
		int *_downers;
};

#endif 
