#ifndef HANSONFITTING_H_DEFINED
#define HANSONFITTING_H_DEFINED

#include "fitting.h"

//stage for unmixing muad output using the Lawson-Hanson algorithm
class HansonFitting { //inheritance classes omitted
	public:
		HansonFitting(Chromophores chrom, const std::vector<float> &wlens, float startwlen, float endwlen, int samples, int bands);
		void generateHansonMatrix(); //create gsl matrix containing the chromophore matrix
		float * doHansonFitting(float *mua); //do the actual fitting
		
		//framework stuff		
		//
		// omitted
		//
		
	private:
		//chromophore matrix to be pseudoinverted
		gsl_matrix *_chromMat;
		
		//framework properties
		//
		// omitted
		//
};

#endif
